package hashproduct.popmatch;

public interface Instance {
	
	public int numPeople();
	
	// Does not include last resorts.
	public int numPosts();
	
	// People are 0 through numPeople - 1.
	// Posts are 0 through numPosts - 1.
	// In addition, -(P+1) is the last resort of person P.
	
	/* Each person has zero or more ranks numbered 0, 1, etc.
	 * LAST_RESORT_RANK is for the person's own last resort.
	 * IMPOSSIBLE_RANK is for another person's last resort or a
	 * post not on the preference list. */
	public int rankFor(int person, int post);
	
	/* Bounds the number of ranks the person could have. */
	public int numRanksFor(int person);
	
	/* Remember to override these.  Use the implementations in Statics. */
	public boolean equals(Object o);
	public int hashCode();
	public String toString();
}
