package hashproduct.popmatch;

public class MarginVotingSolver extends AbstractSolver
		implements ExplainingMatchingImprover {
	private MarginVotingSolver() {
		super("Margin-voting solver");
	}
	public static final MarginVotingSolver it = new MarginVotingSolver();

	public Matching solve(Instance i) {
		return IterativeSolverHelper.iterateToCycle(this, MarginComparator.it, i);
	}
	
	public static boolean regressionsInteresting = false;
	
	public Matching improve(Matching m) {
		MarginAnalysis ma = Marginizer.marginize(m);
		//Logger.out.append(
		//	"MarginVotingSolver trying to improve: \n" + ma + "\n");
		if (ma.unpopularity == 0)
			return null;
		else {
			Matching m2 = ma.better;
			// Hmm, is it actually better?
			if (regressionsInteresting) {
				MarginAnalysis ma2 = Marginizer.marginize(m2);
				if (ma2.unpopularity > ma.unpopularity)
					Logger.isInteresting = true;
			}
			return m2;
		}
	}

	@Override public void explainImprovement(Matching m, StringBuilder out) {
		MarginAnalysis ma = Marginizer.marginize(m);
		out.append(ma.toString());
		out.append('\n');
	}
}
