package hashproduct.popmatch;

import java.util.*;

public class MonotonicMarginVotingSolver extends AbstractSolver
		implements MultipleMatchingImprover {
	private MonotonicMarginVotingSolver() {
		super("Monotonic margin-voting solver");
	}
	public static final MonotonicMarginVotingSolver it = new MonotonicMarginVotingSolver();

	public Matching solve(Instance i) {
		return IterativeSolverHelper.iterateMonotonic(this, MarginComparator.it, i);
	}
	
	@Override public Iterator<Matching> improvementIteratorFor(final Matching m) {
		final PressureAnalysis pa = Pressurizer.pressurize(m);
		return new Iterator<Matching>() {
			int post = 0;
			
			@Override public boolean hasNext() {
				return post < m.instance().numPosts();
			}

			@Override public Matching next() {
				Matching m2 = MatchingImproverUtils.apply(m, pa.nodes[post], true);
				post++;
				return m2;
			}

			@Override public void remove() {
				throw new UnsupportedOperationException();
			}
		};
	}
}
