package hashproduct.popmatch;

public class PressureBumpingSolver extends AbstractSolver
		implements MatchingImprover {
	private PressureBumpingSolver() {
		super("Pressure-bumping solver");
	}
	public static final PressureBumpingSolver it = new PressureBumpingSolver();

	/* This DOES NOT always produce the best solution.
	 * To improve some matchings, one must bump someone of non-maximal
	 * pressure; otherwise one loops without finding the best matching. */
	public Matching solve(Instance i) {
		return IterativeSolverHelper.iterateToCycle(this, FactorComparator.it, i);
	}
	
	public Matching improve(Matching m) {
		PressureAnalysis ma = Pressurizer.pressurize(m);
		if (ma.n == null)
			return null; // yay! everybody got a first choice, no improvement
		MatchingImproverUtils.storeImprovement(ma);
		return ma.better;
	}
}
