package hashproduct.popmatch;
import static hashproduct.popmatch.Statics.*;
import hashproduct.popmatch.util.*;

public final class PressurizationImpl implements Pressurization {
	public Instance instance;
	public int highestPressure;
	public int[] pressures;
	
	public PressurizationImpl(Instance instance, int highestPressure, int[] pressures) {
		this.instance = instance;
		this.highestPressure = highestPressure;
		this.pressures = pressures;
	}
	
	public PressurizationImpl(Instance instance, int[] pressures) {
		this(instance, Arrays.max(pressures), pressures);
	}
	
	public Instance instance() {
		return instance;
	}
	
	public int highestPressure() {
		return highestPressure;
	}
	
	public int pressureFor(int post) {
		if (isALastResort(post))
			return 0;
		else
			return pressures[post];
	}
	
	@Override
	public String toString() {
		return Statics.toString(this);
	}
}
