package hashproduct.popmatch.threesat;
import static hashproduct.popmatch.threesat.Statics.*;

public class InstanceImpl implements Instance {
	public int numVariables;
	public int numStatements;
	public int[][] refs;
	
	public InstanceImpl(int numVariables, int[][] refs) {
		this.numVariables = numVariables;
		numStatements = refs.length;
		this.refs = refs;
	}

	public int referenceAt(int statement, int pos) {
		return refs[statement][pos];
	}

	public int numStatements() {
		return numStatements;
	}

	public int numVariables() {
		return numVariables;
	}
	
	@Override
	public boolean equals(Object o) {
		return (o instanceof Instance) && equal(this, (Instance) o);
	}
	
	@Override
	public int hashCode() {
		return Statics.hashCode(this);
	}
	
	@Override
	public String toString() {
		return Statics.toString(this);
	}
}
