package hashproduct.popmatch.util;

import static java.lang.Math.max;

public class Formatter {
	private Formatter() {}

	public static void formatTable(int numRows, int numCols,
		String[][] cells, StringBuilder sb) {
		int[] colWidths = new int[numCols];
		for (int col = 0; col < numCols; col++) {
			int cw = 0;
			for (int row = 0; row < numRows; row++) {
				String cell = cells[row][col];
				if (cell != null)
					cw = max(cw, cell.length());
			}
			colWidths[col] = cw;
		}
		for (int row = 0; row < numRows; row++) {
			boolean rowIsEmpty = true;
			for (int col = 0; col < numCols; col++) {
				if (cells[row][col] != null) {
					rowIsEmpty = false;
					break;
				}
			}
			if (!rowIsEmpty) {
				for (int col = 0; col < numCols; col++) {
					int len1 = sb.length();
					String cell = cells[row][col];
					if (cell != null)
						sb.append(cell);
					while (sb.length() < len1 + colWidths[col])
						sb.append(' ');
				}
				sb.append('\n');
			}
		}
	}
}
